/*
 * nasd_password.c
 *
 * Cheesy routines to convert a text string into a set of
 * nasd_key_t's in a deterministic manner
 *
 * This is necessary because
 */
/*
 * Copyright (c) 1997,1998,1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Howard Gobioff
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#include <nasd/nasd_options.h>
#include <nasd/nasd_types.h>
#include <cryptolib/libcrypt.h>
#include <nasd/nasd_general.h>

/* This function does nothing except initialize the cryptographic
   keys to fixed constants -- you do *NOT* want to do this in a
   real system. This is purely for ease of debugging  - hgobioff */  
 
nasd_status_t  nasd_security_password_to_keys(char *password,
                                              nasd_key_t master_key,
                                              nasd_key_t drive_key,
                                              nasd_partnum_t partnum,
                                              nasd_key_t part_key,
                                              nasd_key_t red_key,
                                              nasd_key_t black_key){

SHA1_CTX md_context;
unsigned char buff[64];
int i,j;

for(i=0;i<sizeof(nasd_key_t);i++) {
  master_key[i]=1;
  drive_key[i]=2;
  part_key[i]=partnum;
  red_key[i]=partnum+1;
  black_key[i]=partnum+2;
}



return NASD_SUCCESS;
}


