/*
 * nasd_dux_addts.s
 *
 * Atomically add nasd timespecs
 */
/*
 * Copyright (c) 1998,1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Jim Zelenka
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#ifdef __LANGUAGE_C__
#undef __LANGUAGE_C__
#endif /* __LANGUAGE_C__ */
#include <nasd/nasd_options.h>

    .globl  nasd_atomic_add_timespec
    .ent    nasd_atomic_add_timespec 2
nasd_atomic_add_timespec:
    ldgp    $gp, 0($27)
    lda     $sp, -32($sp)
    .frame  $sp, 32, $26, 0

1:
    ldq_l   $1, 0($16)
    stq     $1, 0($sp)

    ldq     $18, 0($sp)

    ldl     $2, 0($sp)
    ldl     $3, 0($17)
    addl    $2, $3, $4
    stl     $4, 0($sp)

    ldl     $5, 4($sp)
    ldl     $6, 4($17)
    addl    $5, $6, $7
    stl     $7, 4($sp)

    bis     $7, $7, $0
    cmpult  $0, 1000000000, $8
    bne     $8, $32

    addl    $0, -1000000000, $22
    stl     $22, 4($sp)

    addl    $4, 1, $23
    stl     $23, 0($sp)

$32:
    ldq     $24, 0($sp)
    stq_c   $24, 0($16)

    beq     $24, 2f

    bis     $18, $18, $0

    lda     $sp, 32($sp)
    ret     $31, ($26), 1
2:
    br      $31,1b

.end  nasd_atomic_add_timespec




#if 0

/*
 * Derived from:
 */

unsigned long
nasd_atomic_add_timespec(
  unsigned long  *tsp1,
  unsigned long  *tsp2)
{
  unsigned int *itsp1, *itsp2;
  unsigned long ots, oots;

  oots = *tsp1;

  itsp1 = (unsigned int *)&oots;
  itsp2 = (unsigned int *)tsp2;

  ots = oots;

  itsp1[0] += itsp2[0];
  itsp1[1] += itsp2[1];
  if (itsp1[1] >= 1000000000) {
    itsp1[1] -= 1000000000;
    itsp1[0]++;
  }

  *tsp1 = oots;

  return(ots);
}
#endif

/* Local Variables:  */
/* indent-tabs-mode: nil */
/* tab-width: 2 */
/* End: */
