/*
 * nasd_dux_timeout_kernel.h
 *
 * Structures and definitions for NASD timeout mechanism
 * inside the dux kernel.
 */
/*
 * Copyright (c) 1998,1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Jim Zelenka
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#ifndef _NASD__NASD_DUX_TIMEOUT_KERNEL_H_
#define _NASD__NASD_DUX_TIMEOUT_KERNEL_H_

#include <nasd/nasd_options.h>
#include <nasd/nasd_threadstuff.h>

typedef struct nasd_timeout_s  nasd_timeout_t;
typedef nasd_uint64            nasd_timeout_handle_t;

#define NASD_TIMEOUT_HANDLE_NULL 0

struct nasd_timeout_s {
  nasd_timespec_t          tm_time;
  nasd_timespec_t          tm_interval;
  nasd_timeout_status_t    tm_status;
  nasd_timeout_handle_t    tm_handle;
  void                   (*tm_proc)(nasd_timeout_handle_t, void *, void *);
  void                    *tm_arg1;
  void                    *tm_arg2;
  nasd_timeout_t          *tm_bprev;
  nasd_timeout_t          *tm_bnext;
  nasd_timeout_t          *tm_prev;
  nasd_timeout_t          *tm_next;
};

#endif /* !_NASD__NASD_DUX_TIMEOUT_KERNEL_H_ */

/* Local Variables:  */
/* indent-tabs-mode: nil */
/* tab-width: 2 */
/* End: */
