/*
 * nasd_linux_platform.h
 */
/*
 * Copyright (c) 1998,1999 Carnegie Mellon University.
 * All rights reserved.
 *
 * Author: Jim Zelenka
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#ifndef _NASD__NASD_LINUX_PLATFORM_H_
#define _NASD__NASD_LINUX_PLATFORM_H_

#if __i386__
#define nasd_int64cast(_n_)   _n_##LL
#define nasd_uint64cast(_n_)  _n_##ULL
#define NASD_64s_FMT          "Ld"
#define NASD_64u_FMT          "Lu"
#define NASD_64x_FMT          "Lx"
#define NASD_64X_FMT          "LX"
#define NASD_ID_FMT           "016Lx"
#endif /* __i386__ */

#if __alpha
#define nasd_int64cast(_n_)   _n_##L
#define nasd_uint64cast(_n_)  _n_##UL
#define NASD_64s_FMT          "ld"
#define NASD_64u_FMT          "lu"
#define NASD_64x_FMT          "lx"
#define NASD_64X_FMT          "lX"
#define NASD_ID_FMT           "016lx"
#endif /* __alpha */

typedef const void * nasd_qsort_arg_type_t;

#define NASD_INLINE __inline

#endif /* !_NASD__NASD_LINUX_PLATFORM_H_ */

/* Local Variables:  */
/* indent-tabs-mode: nil */
/* tab-width: 2 */
/* End: */
