/*
 * nasd_cheops_btree.h
 */
/*
 * B-tree related definitions
 *
 */
/*
 * Copyright (c) 1996,1997,1998,1999 Carnegie Mellon University.
 * All rights reserved.
 *
 * Author: Khalil Amiri, CMU SCS/ECE, July 18 1997
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

/*
 * B-tree data structure definition
 */
#ifndef  _NASD_CHEOPS_BTREE_H_
#define  _NASD_CHEOPS_BTREE_H_

#define D 6 
#define NULL_MFP NULL
#define MAX_BTREE_NODES 2000

#define FULL_NODE(t) ( t->d == 2*D )
typedef int nodeid_t;

typedef int typekey;
typedef int node_ptr_t;

typedef struct node_s {       
  int level;                  /* Level 0: leaf node                  */
  int nodeid;		      /* page id                             */
  int d;                      /* number of active entries            */
  typekey k[2*D+1];           /* Keys                                */
  node_ptr_t  p[2*D+2];       /* Pointers to children nodes          */
} node_t, *btree_t;

typedef struct keynode_pair_s {
 typekey key;
 node_ptr_t nodeid;
} keynode_pair_t; 

#endif /* _NASD_CHEOPS_BTREE_H_ */








