/*
 * nasd_cheops_mgr_common.h 
 */
/*
 * common CHEOPS storage manager definitions
 *
 */
/*
 * Copyright (c) 1996,1997,1998,1999 Carnegie Mellon University.
 * All rights reserved.
 *
 * Author: Khalil Amiri, CMU SCS/ECE, July 18 1997
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#ifndef _NASD_CHEOPS_MGR_COMMON_H_
#define _NASD_CHEOPS_MGR_COMMON_H_

typedef enum { NASD_CHEOPS_OP_BS_CREATE,
	       NASD_CHEOPS_OP_BS_REMOVE,
	       NASD_CHEOPS_OP_BS_LOOKUP,
	       NASD_CHEOPS_OP_BS_GETATTR,
	       NASD_CHEOPS_OP_BS_SETATTR,
	       NASD_CHEOPS_OP_DR_LOOKUP,
	       NASD_CHEOPS_OP_MGR_LOOKUP,
	       NASD_CHEOPS_OP_FAIL_REPORT
} nasd_cheops_mgr_op_t;

/* options */
extern int Default_Stripe_Unit_Size;
extern _NASD_CHEOPS_raid_level_t Default_RAID_Level;
extern int Default_Stripe_Width;

#endif /* _NASD_CHEOPS_MGR_COMMON_H_ */

