/*
 * nasd_itypes.h
 *
 * Common types for NASD prototype
 */
/*
 * Copyright (c) 1996,1997,1998,1999 Carnegie Mellon University.
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#ifndef _NASD_ITYPES_H_
#define _NASD_ITYPES_H_

#include <nasd/nasd_options.h>
#include <nasd/nasd_types.h>

typedef struct NASD_drive_comm_s   NASD_drive_comm_t;
typedef struct nasd_mem_list_s     nasd_mem_list_t;
typedef struct nasd_freelist_s     nasd_freelist_t;
typedef struct nasd_threadgroup_s  nasd_threadgroup_t;

struct nasd_mem_list_s {
  void             *addr;
  int               len;
  int               stride;
  int               nelem;
  nasd_mem_list_t  *next;
};

#endif /* _NASD_ITYPES_H_ */
