/*
 * Copyright (c) 1996,1997,1998,1999 Carnegie Mellon University.
 * All rights reserved.
 *
 * Author: Howard Gobioff
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

/***********************************************************************
 *
 * nasd_keymgmt.h
 *
 * Routines to access keys 
 *
 ***********************************************************************/

#ifndef _NASD_KEYMGMT_H_ 
#define _NASD_KEYMGMT_H_

#include <nasd/nasd_options.h>
#include <nasd/nasd_types.h>

/* default path for a file manager to find is keys */
#define NASD_DEFAULT_KEYFILE "./my_keys"

nasd_status_t nasd_security_get_red_key(nasd_partnum_t part, nasd_key_t target);
nasd_status_t nasd_security_get_black_key(nasd_partnum_t part, nasd_key_t target);
nasd_status_t nasd_security_get_partition_key(nasd_partnum_t part, nasd_key_t target);
nasd_status_t nasd_security_get_drive_key(nasd_key_t target);
nasd_status_t nasd_security_get_master_key(nasd_key_t target);





nasd_status_t nasd_security_set_red_key(nasd_partnum_t part, nasd_key_t target);
nasd_status_t nasd_security_set_black_key(nasd_partnum_t part, nasd_key_t target);
nasd_status_t nasd_security_set_partition_key(nasd_partnum_t part, nasd_key_t target);
nasd_status_t nasd_security_set_drive_key(nasd_key_t target);




nasd_status_t nasd_security_initialize_drive(nasd_key_t master_key, nasd_key_t drive_key);
/* When linked in a drive, the paramter is ignored so just pass in a NULL */
/* When linked in a test program or a file manager, the char * is the name
   of the file where the diskstate (and keys) are stored*/

nasd_status_t nasd_security_init_key_mgmt(char *keyfile,char *password,int init_from_key);


nasd_status_t nasd_security_change_key_drive(nasd_uint16,nasd_key_t ,nasd_partnum_t);
#endif
