/*
 * Copyright (c) 1997,1998,1999 Carnegie Mellon University.
 * All rights reserved.
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

/***********************************************************************
 *
 * nasd_security_capability.h
 *
 * Support functions to help file mangagers handle capabilities
 *
 ***********************************************************************/

#ifndef _NASD_SECURITY_CAPABILITY_H_
#define _NASD_SECURITY_CAPABILITY_H_

#include <nasd/nasd_options.h>

void nasd_security_build_capability(nasd_drive_name_t  drive_name,
                                    nasd_partnum_t partnum,
				    nasd_identifier_t ni,
				    nasd_access_rights_t rights,
				    nasd_audit_t AuditID,
				    nasd_int32 expiration,
				    nasd_uint16 min_protection,
                                    nasd_uint16 type,
                                    nasd_offset_t region_start,
                                    nasd_offset_t region_end,
				    nasd_av_t av,
				    nasd_cookie_t* out_cookie);

void nasd_security_print_capability(nasd_cookie_t *cookie);
#endif
