/*
 * nasd_threads_lwp.h
 *
 * LWP variant of threads portability layer.
 */
/*
 * Copyright (c) 1995,1996,1997,1998,1999 Carnegie-Mellon University.
 * All rights reserved.
 *
 * Author: Howard Gobioff
 *
 * Permission to use, copy, modify and distribute this software and
 * its documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.
 *
 * CARNEGIE MELLON ALLOWS FREE USE OF THIS SOFTWARE IN ITS "AS IS"
 * CONDITION.  CARNEGIE MELLON DISCLAIMS ANY LIABILITY OF ANY KIND
 * FOR ANY DAMAGES WHATSOEVER RESULTING FROM THE USE OF THIS SOFTWARE.
 *
 * Carnegie Mellon requests users of this software to return to
 *
 *  Software Distribution Coordinator  or  Software.Distribution@CS.CMU.EDU
 *  School of Computer Science
 *  Carnegie Mellon University
 *  Pittsburgh PA 15213-3890
 *
 * any improvements or extensions that they make and grant Carnegie Mellon the
 * rights to redistribute these changes.
 */

#ifndef _NASD__NASD_THREADS_LWP_H_
#define _NASD__NASD_THREADS_LWP_H_

#include <nasd/nasd_options.h>
#include <lock.h>
#include <lwp.h>

/* XXX  - hgobioff  - this needs to be filled in */

#define NASD_DECLARE_MUTEX(_m_) struct Lock _m_ ;
#define NASD_LOCK_MUTEX(_m_) ObtainWriteLock(&(_m_))
#define NASD_UNLOCK_MUTEX(_m_) ReleaseWriteLock(&(_m_))
#define nasd_mutex_init(_m_) 

#endif /* !_NASD__NASD_THREADS_LWP_H_ */

/* Local Variables:  */
/* indent-tabs-mode: nil */
/* tab-width: 2 */
/* End: */
