/*
 *  expr.h
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

extern Expr *make_op (Expr *left, int op, Expr *right);
extern Expr *do_expr_op (Expr *left, int op, Expr *right);
extern Expr *const_to_expr (Constant *theconst);
extern Expr *prefix_op (int op, Expr *theexpr);
extern Expr *postfix_op (int op, Expr *theexpr);
extern Expr *ident_to_expr (Constant *theconst);
extern Expr *clean_expr (Expr *theexpr);
extern Expr *add_exprs (Expr *left, Expr *right);
extern Expr *mul_exprs (Expr *left, Expr *right);
extern Expr *int_to_expr (int x);
extern Expr *make_bit_unit (Expr *p);
extern Expr *bit_to_expr (int x);
extern void bit_expr_to_byte_expr (Expr *theexpr);
