/*
 *  twiddle.c -- basic bit handling routines.
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

#include "usc.h"
#include "twiddle.h"


int num_set_bits (unsigned long value)
{
  int count;

  for (count = 0; value; count++)
    value &= (value - 1);
  return count;
}

int which_bit_set (unsigned long value)
{
  int count;

  for (count = 0; !(value & 1) && count < sizeof (unsigned long) * 8; 
       count++, value >>= 1);
  return count;
}

int gcd(int a, int b)
{
  int tmp;
  
  if (b > a)
  {
    tmp = a; a = b; b = tmp;
  }
  for(;;)
  {
    if (b == 0)
      return a;
    else if (b == 1)
      return b;
    else
    {
      tmp = b;
      b = a % b;
      a = tmp;
    }
  }
}
