/*
 *  usit.h
 *
 *  Copyright 1994, 1995 by the Arizona Board of Regents.
 *
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that this notice appears in all copies and supporting documentation.
 *  This software is provided "as is", with no warranty.
 */

#define VERSION "USIT version 2.1"

typedef enum {
  USIT_OUT_INFER_CODE  = 1,
  USIT_OUT_USC_CODE    = 2,
  USIT_IN_C_CODE       = 4,
  USIT_IN_INFER_OUTPUT = 8
} UsitMode;

typedef enum {
  TYPEDEF_CLASS,
  SYMBOL_CLASS,
  STRUCT_CLASS,
  UNION_CLASS
} UsitClass;

typedef struct usit_declaration {
  UsitClass the_class;
  Symbol *the_sym;   /* if the declaration is of a struct or union,
			make it into a sym */
  struct usit_declaration *next;
} UsitDecl;

typedef struct {
  UsitDecl *head, *tail;
} UsitDecList;

typedef struct {
  FILE *out;
  void *data;
} PtabPayload;

extern char *native_compiler;
extern UsitMode usit_output, usit_input;
extern FILE *UsitData;
extern char *UsitDataFile;

extern void run_preprocess (void);
